#! /usr/bin/env node

// CodeNote by Ryan Petroff - https://gitlab.com/petroff.ryan/codenote
// forked from Kajero

// SUMMARY:
// Put in a markdown file, get an html notebook app

// STRUCTURE OF THIS FILE
// - Dependencies
// - Inputs
// - Outputs

// TODO: add a DEBUG mode --debug
// TODO: keep improving errors - and enough emoji to smile about 'em. Pretty good so far!
// TODO: make md mode generate the best headers possible
// TODO: tests? some simple ones

/////////////////////////
///////// Dependencies //
/////////////////////////

// cli ux niceness (tab autocomplete, help autogenerated, etc)
var yargs = require('yargs');      // an incredible cross-platform asset for us!

// Internet assets
var request = require('request');        // to make requests across the internet

// Files and filesystems
var fs = require('fs');             // to interact with files and the filesystem
var path = require('path');                     // to help with filesystem paths
// Willing to change these to cross-platform,
//    but firmly committed to linux first, no windows-only code,
//        only cross-platform victories/libraries

// CodeNote's shipped js & css
var js = fs.readFileSync(path.resolve(__dirname, 'bundle.js')).toString();  // __dirname is the directory of this script at the time it is called
var css = fs.readFileSync(path.resolve(__dirname, 'main.css')).toString();
var cssfonts = fs.readFileSync(path.resolve(__dirname, 'fontbundle.css')).toString();

/////////////////////////
// End of Dependencies //
/////////////////////////

///////////////////
///////// Inputs //
///////////////////

// yargs will nice up the CLI UX and seperate out the info we need
var argv = yargs
  .usage('usage: $0 <command> <commandargument>')
  .command('md <filename>', 'generate a fresh markdown file', (yargs) => {
      yargs
        .positional('filename', {
          describe: 'name of new markdown file'
        })
        .example('$0 md myfile.md','This will generate a nice myfile.md')
        .example('$0 md myfile','This will also generate a nice myfile.md')
    }, (argv) => {
      if (argv.verbose) console.info(`generating fresh markdown file :${argv.filename}`)
      //////////////////////////////////////////////////////////////
      md_mode(argv.filename) // CONTROL FLOW  //     //    //    //
      ////////////////////////////////////////////////////////////
  })
  .command('html <markdownfile>', 'generate html notebook from markdown file', (yargs) => {
      yargs
        .positional('markdownfile', {
          describe: 'name of target markdown file'
        })
        .example('$0 html myfile.md','This will use myfile.md to generate myfile.html')
    }, (argv) => {
      if (argv.verbose) console.info(`generating html from markdown file :${argv.markdownfile}`)
      ////////////////////////////////////////////////////////////////////
      html_mode(argv.markdownfile); // CONTROL FLOW  //     //   //    //
      //////////////////////////////////////////////////////////////////
  })
  .command('live <livemarkdownfile>', 'continously live rebuild markdown and refresh notebook in the browser', (yargs) => {
      yargs
        .positional('livemarkdownfile', {
          describe: 'live mode target markdown file'
        })
    }, (argv) => {
      if (argv.verbose) console.info(`Entering live mode rebuilding :${argv.livemarkdownfile}`)
      ////////////////////////////////////////////////////////////////////
      live_mode(argv.livemarkdownfile); // CONTROL FLOW  //     //   //    //
      //////////////////////////////////////////////////////////////////
  })
  .command('publish <publishmarkdownfile>', 'Publish a notebook publicly, built fresh from source markdown', (yargs) => {
      yargs
        .positional('publishmarkdownfile', {
          describe: 'publish mode target markdown file'
        })
    }, (argv) => {
      if (argv.verbose) console.info(`Publishing :${argv.publishmarkdownfile}`)
      ////////////////////////////////////////////////////////////////////
      publish_mode(argv.publishmarkdownfile); // CONTROL FLOW  //     //   //    //
      //////////////////////////////////////////////////////////////////
  })
  .option('verbose', { // are there other jokes options for options? :3
      alias: 'v',
      default: false
  })
  //.option('debug' ... check docs, ryan ;) )
  .completion('completion', function(current, argv) {
      // 'current' is the current command being completed.
      // 'argv' is the parsed arguments so far.
      // simply return an array of completions.
      // ...
      // also, do we really need to edit .bashrc?! look into how completions even happen at all
      return [
        'md',
        'html',
        'live',
        'publish'
      ];
  })
  .recommendCommands() // love it! good luck thanks to reading the api! make sure this executes before 'friendly greeting'
  .help()
  .epilog(' 💖  CodeNote loves you unconditionally  💖 ')
  .argv

// friendly logging
// console.log(process.argv,process.cwd(),argv);

// friendly greeting for those just showing up and executing codenote
if ((argv._.length == 0) || !((argv._[0] == 'md') || (argv._[0] == 'html') || (argv._[0] == 'live') || (argv._[0] == 'publish'))) {
    console.error("Welcome to CodeNote!\nAvailable commands:\n  🔧   md\n  🔧   html\n  🔧   live\n  🔧   publish\nor you can ask for help with:\n  codenote --help \n                   💖  Don't give up! 💖  ");
    return
}

///////////////////
// End of Inputs //
///////////////////


////////////////////
///////// Outputs //
////////////////////

function saveHTML(markdown, markdownfilename) {
    var result = "<!DOCTYPE html>\n<html>\n    <head>\n";
    result += '        <meta name="viewport" content="width=device-width, initial-scale=1">\n';
    result += '        <meta http-equiv="content-type" content="text/html; charset=UTF8">\n';
    result += '        <base target="_blank">\n';
    result += '    </head>\n    <body>\n        <script type="text/markdown" id="codenote-md">\n';
    result += markdown.split('\n').map((line) => {
        if (line.match(/\S+/m)) {
            return '            ' + line;
        }
        return '';
    }).join('\n');
    result += '        </script>\n';
    result += '        <div id="codenote"></div>\n';
    //
    // Here is where the css+js are inlined
    //
    result += '         <style>\n'
    result += cssfonts
    result += '         </style>\n'
    result += '         <style>\n'
    result += css
    result += '         </style>\n'
    result += '         <script type="text/javascript">\n'
    result += js  // will there be strange escaping consequences down the line?
    result += '         </script>\n'
    // css+js inlining complete
    result += '    </body>\n</html>\n';


    // the .html file will be written with the name of the input.md,
    // and placed wherever the codenote tool was called from,
    // so pwd/input.html :)
    var fileHere = process.cwd() + "/" + markdownfilename.split('/').slice(-1)[0].split('.')[0] + ".html";

    fs.writeFile(fileHere, result, function(err) {
    // This is where cross-platform bugs will crop up. How to universalize file access?
    if(err) {
        return console.log(err);
    }

    console.log("The file was saved!", fileHere);
    });


}

function md_mode(filename) {

  if (filename.split('.').slice(-1) != 'md') { filename += '.md'} // add .md to the filename if missing

  var mdfileHere = process.cwd() + "/" + filename; // path to the file

  if (fs.existsSync(mdfileHere)) {
        console.error("Whoa! " + filename + " already exists here! Aborting this operation in the name of caution. " + mdfileHere + " has been spared.")
        return filename;
  }

  var titlestring = `"`+filename.split('.')[0]+`"`; // make the filename the title
  var datetimestring = new Date(); datetimestring = '"' + datetimestring.toDateString() + ' ' + datetimestring.toTimeString() + '"'; //this is to conform with OG Kajero, which I like somehow

  // TODO: what are all the valid header strings? What will codenote add?
  // we want to collect accurate, useful data. maybe an email field?
  //var authorstring = `"Ryan Petroff"`; // This should be read from somewhere, or just asked of the user
  var authorstring = `"Anonymous Scientist"`; // Prompt the user to change it?
  // require("os").userInfo().username  gets us ~something
  // but we must ask the cli user if that name is right, and give them the chance to correct it

  var header = `---
title: ${titlestring}
author: ${authorstring}
created: ${datetimestring}
show_footer: true
---
`;
  var blankcontent = `## I'm a blank notebook.

This is a CodeNote notebook, but there's nothing in it yet. Click the edit button on the top-right to get started!
`;
  var md_file_contents = header + blankcontent;

  fs.writeFile(mdfileHere, md_file_contents, function(err) {
  // This is where cross-platform bugs will crop up. How to universalize file access?
  if(err) {
      return console.log(err);
  }

  console.log("Fresh Markdown file, ready and waiting!", mdfileHere);
  });
}

function html_mode(markdownfile){
  // renamed savedHTML
  var md = fs.readFileSync(markdownfile).toString(); //assuming file exists
  // check for the existence of the .html target too
  saveHTML(md, markdownfile);
}

function live_mode(livemarkdownfile) {
  // watch and reload plus html_mode
  // check the markdown file really exists

  // enter some kind of watch-loop
  // that can be exited, and exited cleanly
}

function publish_mode(publishmarkdownfile) {
    // So, the cli can call this!
    // Guess we better implement something! :)



      //some publish functionality will come, but in a later version
    // Gists can come back later, once I understand them
    /*
    function saveGist(markdown) {
        var options = {
            uri: 'https://api.github.com/gists',
            method: 'POST',
            headers: {
                'User-Agent': 'codenote'
            },
            json: {
                description: 'codenote notebook',
                public: true,
                files: {
                    'notebook.md': {
                        content: md
                    }
                }
            }
        };

        request(options, function(err, response, body) {
            console.log('http://www.joelotter.com/kaje ro/?id=' + body.id);
        });
    }
    */
    // This Gist thing is super nice, actually! Great feature!
}
